//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Receptionist, ReceptionistDocument } from '../Receptionist';
import { ReceptionistService } from '../ReceptionistService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Receptionist')
@UseBefore(checkApiDisabled(ReceptionistBaseController))
export class ReceptionistBaseController extends BaseController {
    protected model: Model<ReceptionistDocument>;

    protected static readonly _objName: string = 'Receptionist';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ,
        create: MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(receptionistService: ReceptionistService) {
        super(Receptionist, receptionistService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async getAllReceptionist(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async getOneReceptionist(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async postReceptionist(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async patchReceptionist(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async deleteReceptionist(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsReceptionist(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async getCsvExportReceptionist(@Res() response, @QueryParams() query) {
        response.attachment(`${ReceptionistBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async getXlsxExportReceptionist(@Res() response, @QueryParams() query) {
        response.attachment(`${ReceptionistBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(ReceptionistBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.RECEPTIONIST.READ))
    @UseBefore(authenticated)
    public async getPdfExportReceptionist(@Res() response, @QueryParams() query) {
        response.attachment(`${ReceptionistBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
